from dune.perftool.preambles import dune_preamble, dune_symbol, loop_domain, loopy_iname, temporary_variable, loopy_c_instruction, loopy_expr_instruction
from dune.perftool.pdelab_names import name

@dune_symbol
def test_function_name(arg, grad):
    return "{}a{}".format("grad_" if grad else "", arg.number())

@dune_symbol
def trial_function_name(arg, grad):
    return "{}c{}".format("grad_" if grad else "", arg.count())

@dune_symbol
def index_name(index):
    return str(index._indices[0])

@loop_domain
def argument_loop_domain(name):
    return name

@loopy_iname
def argument_iname(arg):
    name = "arg{}".format(chr(ord("i") + arg.number()))
    argument_loop_domain(name)
    return name

@dune_symbol
def dimension():
    return "dim"

@loop_domain
def quadrature_loop_domain(name):
    return name

@loopy_iname
def quadrature_iname():
    quadrature_loop_domain("q")
    return "q"

from dune.perftool.preambles import _dune_decorator_factory, CInstructionCacheItem
quadrature_preamble = _dune_decorator_factory(cache_item_type=CInstructionCacheItem, inames=quadrature_iname())

@dune_symbol
def quadrature_rule():
    return "rule"

@quadrature_preamble(assignees=name("quadrature_factor"))
def define_quadrature_factor():
    rule = quadrature_rule()
    return "auto {} = {}->weight();".format(name("quadrature_factor"), rule)

@temporary_variable
def quadrature_factor():
    define_quadrature_factor()
    return name("quadrature_factor")

@loop_domain(upperbound=dimension())
def dimension_loop_domain(name):
    return name

@loopy_iname
def dimension_iname(index):
    dimension_loop_domain(index_name(index))
    return index_name(index)

@dune_symbol
def residual_name():
    return "r"

@loopy_expr_instruction
def accumulation_instruction(expr):
    return expr